#include <math.h>
#include "header.h"

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,p2) 
 * This is stretched out to be readable.  Variables can be 
 * eliminated and loops combined.  Includes the subterfuge.
 */
void weights1(int t1, int p1, int t2){
  int u, p2, mask[UNDERLIERS], points;
  double f[POINTS], g[POINTS], arg[POINTS], growth[UNDERLIERS][POINTS];

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  for(u=0;u<UNDERLIERS;++u){ 
    if(Prob[t1][u][p1] > PROBCUTOFF){ 
      mask[u] = 1; 
    }else{ 
      mask[u] = 0; 
    } 
  } 
  
  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += mask[u]*(growth[u][p2] - (INTEREST-DIVIDEND))*(growth[u][p2] - (INTEREST-DIVIDEND))/VARIANCE;
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }




  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2+1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += mask[u]*(growth[u][p2] - (t2+1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2+1)*(INTEREST-DIVIDEND))/((t2+1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    g[p2] = exp(-0.5*arg[p2]);
  }
  

  for(p2=0;p2<points;++p2){
    Weight[p2] = f[p2]/g[p2];
    Sum_weights += f[p2]/g[p2];
  }
}

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,p2) This is
 * stretched out to be readable.  Variables can be eliminated and
 * loops combined.  Does not include the subterfuge, so it can be used
 * to calculate the probabilities needed to implement the subterfuge.
 * */

void weights2(int t1, int p1, int t2){
  int u, p2, points;
  double f[POINTS], g[POINTS], arg[POINTS], growth[UNDERLIERS][POINTS];

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += (growth[u][p2] - (INTEREST-DIVIDEND))*(growth[u][p2] - (INTEREST-DIVIDEND))/VARIANCE;
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }




  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2+1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += (growth[u][p2] - (t2+1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2+1)*(INTEREST-DIVIDEND))/((t2+1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    g[p2] = exp(-0.5*arg[p2]);
  }
  

  for(p2=0;p2<points;++p2){
    Weight[p2] = f[p2]/g[p2];
    Sum_weights += f[p2]/g[p2];
  }
}
